% need to change loglik.m; score.m; recursive.m; calder.m;
% calder_marginal.m
function [G, dG, ddG, d3G]=Gtransform(temp, sig2, type)
if strcmp(type, 'Cox')
    G=log(temp);
    dG=1;
    ddG=0;
    d3G=0;
end

if strcmp(type, 'probit')||strcmp(type, 'logistic')
    mean=0;
    sig=sqrt(sig2);
    Phi=0.5+normcdf(log(temp), mean, sig)-normcdf(0, mean, sig);
    temp2=normpdf(log(temp), mean, sig);
    phi=temp2./temp;
    dphi=-temp2./(temp.^2)-((log(temp)-mean)./(temp*sig2)).*temp2./temp;
    d2phi=2*(temp.^(-3)).*temp2+2*(temp.^(-2)).*temp2.*((log(temp)-mean)./(temp*sig2))...
        +(temp.^(-1)).*temp2.*(((log(temp)-mean)./(temp*sig2)).^2)...
        -temp.^(-1).*temp2.*(1./(sig2*(temp.^2)))+temp.^(-1).*temp2.*((log(temp)-mean)./(temp.^2*sig2));
    
    G=-log(1-Phi);
    dG=phi./(1-Phi);
    ddG=dphi./(1-Phi)+(phi./(1-Phi)).^2;
    d3G=d2phi./(1-Phi)+(dphi.*phi)./((1-Phi).^2)+2*phi.*dphi./((1-Phi).^2)+(2*phi.^3)./((1-Phi).^3);
end

