function [G, der, eta, dereta]=calder_marginal(zz, betas, Sf1, sigma2, Xbar)
q=size(Xbar, 2);
b0=Xbar*betas(1:q);
bz=betas(end);

nn=length(Sf1);
Lambda_t_all=cumsum(Sf1);
eta=b0+bz*zz;
[G, dG, ddG, d3G]=Gtransform_norm(exp(eta)*Lambda_t_all, 0, sigma2);
dereta=[Xbar, zz];

dertemp2=[(Lambda_t_all*dereta)'; (triu(ones(nn, nn), 0))];
dertemp3=dertemp2.*exp(eta);
der=repmat((exp(-G).*(-dG))', size(dertemp3, 1), 1).*dertemp3;

