function[coef, cov_coef, sig2, Dlogfi, DDlogf]=normeq(Xtemp, Ytemp)
[n, p]=size(Xtemp);
XXt=Xtemp'*Xtemp;
XXtinv=inv(XXt);
coef=(XXtinv)*Xtemp'*Ytemp;
Ypred=Xtemp*coef;
sig2=sum((Ytemp-Ypred).^2)/(length(Ytemp)-0);
cov_coef=sig2.*XXtinv;
ubi=repmat(Ytemp-Xtemp*coef, 1, p).*Xtemp;
usi=repmat(sig2, n, 1)-(Ytemp-Xtemp*coef).^2;
ubi=ubi./sig2;
usi=usi./(-2*sig2^2);
Dlogfi=[ubi, usi];
DDlogf=zeros(p+1, p+1);
DDlogf(1:p, 1:p)=XXt./sig2;
DDlogf(p+1, p+1)=n./(2*sig2^2);

end